#ifndef CONTROLCENTER_SYSTEM_IO_LOGWRITER_H
#define CONTROLCENTER_SYSTEM_IO_LOGWRITER_H

#include <string>
#include <filesystem>


namespace ControlCenter
{
	namespace System
	{
		namespace IO
		{
			class LogWriter final
			{
// **********************************************************************************************************************************************************************************************************************************************************************************************
			// Constructor and destructor

			public:
				LogWriter();
				LogWriter(const std::filesystem::path& logFilePath);
				~LogWriter() = default;

			// Constructor and destructor
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
			// Public methods

			public:
				void report(const std::string& message);

			// Public methods
// **********************************************************************************************************************************************************************************************************************************************************************************************

			private:
				static std::filesystem::path m_logFilePath;

			private:
				LogWriter(const LogWriter&) = delete;
				LogWriter(LogWriter&&) noexcept = delete;
				LogWriter& operator=(const LogWriter&) = delete;
				LogWriter& operator=(LogWriter&&) noexcept = delete;
			};
		}
	}
}


#endif // !CONTROLCENTER_SYSTEM_IO_LOGWRITER_H
