#ifndef CONTROLCENTER_WINDOW_MATEVENT_H
#define CONTROLCENTER_WINDOW_MATEVENT_H

#include <filesystem>

#include "OrderForm.h"
#include "Clock.h"


namespace ControlCenter
{
	namespace Window
	{
		class MATEVENT final
		{
			using Clock = ControlCenter::System::Clock;

// **********************************************************************************************************************************************************************************************************************************************************************************************
		// Constructor and destructor

		public:
			MATEVENT(int argc, char* argv[]);
			~MATEVENT() = default;

		// Constructor and destructor
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
		// Public methods

			int execute();

		// Public methods
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
		// Private methods

		private:
			bool needCustomerSupport() const;
			void executeCustomerSupport() const;

			void setEnvironmentVariables(const OrderForm&) const;
			OrderForm readOrderForm() const;
			void reportElapsedTime();

		// Private methods
// **********************************************************************************************************************************************************************************************************************************************************************************************

		private:
			std::size_t m_mpiNumber;
			std::filesystem::path m_orderSheetPath;
			bool m_demandCustomerSupport;
			Clock m_clock;


		private:
			MATEVENT() = delete;
			MATEVENT(const MATEVENT&) = delete;
			MATEVENT(MATEVENT&&) noexcept = delete;
			MATEVENT& operator=(const MATEVENT&) = delete;
			MATEVENT& operator=(MATEVENT&&) noexcept = delete;
		};
	}
}

#endif // !CONTROLCENTER_WINDOW_MATEVENT_H
