#include "CrystallizationPlan.h"

#include "PeriodicLiquid.h"
#include "MinimumConstrainter.h"
#include "MinMaxConstrainter.h"

using namespace SolidStatePhysics::Crystallization::Simulators;

// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
// Constructor

CrystallizationPlan::CrystallizationPlan()
	: m_maxGeomatricalOptimizing{ 0 }
	, m_maxBondingLengthErrorRate{ 0.0 }
	, m_minPackingFraction{ 0.0 }
	, m_pressure{ SolidStatePhysics::Crystallization::Components::PeriodicLiquid::getDefaultPressure() }
	, m_attractiveForceConstant{ SolidStatePhysics::Crystallization::Calculators::MinMaxConstrainter::getDefaultAttractiveForceConstant() }
	, m_repulsiveForceConstant{ SolidStatePhysics::Crystallization::Calculators::MinMaxConstrainter::getDefaultRepulsiveForceConstant() }
	, m_globalOptimizationVariables{}
	, m_localOptimizationVariables{}
{
}

// Constructor
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
// Utility

void CrystallizationPlan::clear() noexcept
{
	m_maxGeomatricalOptimizing = 0;
	m_maxBondingLengthErrorRate = 0.0;
	m_minPackingFraction = 0.0;
	m_pressure = SolidStatePhysics::Crystallization::Components::PeriodicLiquid::getDefaultPressure();
	m_attractiveForceConstant = SolidStatePhysics::Crystallization::Calculators::MinMaxConstrainter::getDefaultAttractiveForceConstant();
	m_repulsiveForceConstant = SolidStatePhysics::Crystallization::Calculators::MinMaxConstrainter::getDefaultRepulsiveForceConstant();

	m_globalOptimizationVariables.clear();
	m_localOptimizationVariables.clear();
}

// Utility
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
