#include "MdFileOwner.h"

#include <fstream>

#include "PeriodicTable.h"

using namespace SolidStatePhysics::Materials::IO;

// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
// Constructors

MdFileOwner::MdFileOwner(const std::filesystem::path& mdFilePath)
	: FileOwner{ mdFilePath }
{
	if (!(isCorrectExtension(filePath())))
	{
		std::string errorMessage = "------------------------------------------------------\n\n";
		errorMessage += "Error   : Invalid argument\n";
		errorMessage += "Location: The constructor of the class of SolidStatePhysics::Materials::IO::MdFileOwner.\n";
		errorMessage += "Message : The extension of mdFilePath, which is ";
		{
			errorMessage += filePath().generic_string();
			errorMessage += ", is not \"";
			errorMessage += correctExtension();
			errorMessage += "\".\n\n";
		}
		errorMessage += "------------------------------------------------------\n\n";
		throw std::invalid_argument(errorMessage);
	}
}

MdFileOwner::MdFileOwner(std::filesystem::path&& mdFilePath)
	: FileOwner{ mdFilePath }
{
	if (!(isCorrectExtension(filePath())))
	{
		std::string errorMessage = "------------------------------------------------------\n\n";
		errorMessage += "Error   : Invalid argument\n";
		errorMessage += "Location: The constructor of the class of SolidStatePhysics::Materials::IO::MdFileOwner.\n";
		errorMessage += "Message : The extension of mdFilePath, which is ";
		{
			errorMessage += filePath().generic_string();
			errorMessage += ", is not \"";
			errorMessage += correctExtension();
			errorMessage += "\".\n\n";
		}
		errorMessage += "------------------------------------------------------\n\n";
		throw std::invalid_argument(errorMessage);
	}
}

// Constructors
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
