#include "NumericVectorSlice.h"

#include "NumericVector.h"
#include "NumericMatrix.h"

using namespace NumericalAnalysis::LinearAlgebra;


// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
// Private constructors

NumericVectorSlice::NumericVectorSlice(std::valarray<value_type>& va, const std::slice& sl)
	: m_numericVectorSlice{ va }
	, m_start{ sl.start() }
	, m_size{ sl.size()}
	, m_stride{ sl.stride() }
{
	{
		if (m_size == 0)
		{
			std::string errorMessage = "------------------------------------------------------\n\n";
			errorMessage += "Error   : Invalid argument\n";
			errorMessage += "Location: The constructor of the class of NumericalAnalysis::LinearAlgebra::NumericVectorSlice.\n";
			errorMessage += "Message : The size of std::slice is zero.\n\n";
			errorMessage += "------------------------------------------------------\n\n";
			throw std::invalid_argument(errorMessage);
		}

		if (m_stride == 0)
		{
			std::string errorMessage = "------------------------------------------------------\n\n";
			errorMessage += "Error   : Invalid argument\n";
			errorMessage += "Location: The constructor of the class of NumericalAnalysis::LinearAlgebra::NumericVectorSlice.\n";
			errorMessage += "Message : The stride of std::slice is zero.\n\n";
			errorMessage += "------------------------------------------------------\n\n";
			throw std::invalid_argument(errorMessage);
		}
	}

	const size_type numericVectorSize = va.size();
	const size_type lastIndex = m_start + ((m_size - 1) * m_stride);

	if (numericVectorSize <= lastIndex)
	{
		std::string errorMessage = "------------------------------------------------------\n\n";
		errorMessage += "Error   : Invalid argument\n";
		errorMessage += "Location: The constructor of the class of NumericalAnalysis::LinearAlgebra::NumericVectorSlice.\n";
		errorMessage += "Message : The size of input valarray is not more than the required size from std::slice.\n\n";
		errorMessage += "------------------------------------------------------\n\n";
		throw std::invalid_argument(errorMessage);
	}
}

// Private constructors
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
// Arithmetic functions

