#include "PeriodicTable.h"

using namespace SolidStatePhysics::ChemicalElements;

// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
// Methods

std::string PeriodicTable::replyElementSymbol(const std::size_t atomicNumber)
{
	validateAtomicNumber(atomicNumber);

	switch (atomicNumber)
	{
	case 1:
		return std::string{ "H" };

	case 2:
		return std::string{ "He" };

	case 3:
		return std::string{ "Li" };

	case 4:
		return std::string{ "Be" };

	case 5:
		return std::string{ "B" };

	case 6:
		return std::string{ "C" };

	case 7:
		return std::string{ "N" };

	case 8:
		return std::string{ "O" };

	case 9:
		return std::string{ "F" };

	case 10:
		return std::string{ "Ne" };

	case 11:
		return std::string{ "Na" };

	case 12:
		return std::string{ "Mg" };

	case 13:
		return std::string{ "Al" };

	case 14:
		return std::string{ "Si" };

	case 15:
		return std::string{ "P" };

	case 16:
		return std::string{ "S" };

	case 17:
		return std::string{ "Cl" };

	case 18:
		return std::string{ "Ar" };

	case 19:
		return std::string{ "K" };

	case 20:
		return std::string{ "Ca" };

	case 21:
		return std::string{ "Sc" };

	case 22:
		return std::string{ "Ti" };

	case 23:
		return std::string{ "V" };

	case 24:
		return std::string{ "Cr" };

	case 25:
		return std::string{ "Mn" };

	case 26:
		return std::string{ "Fe" };

	case 27:
		return std::string{ "Co" };

	case 28:
		return std::string{ "Ni" };

	case 29:
		return std::string{ "Cu" };

	case 30:
		return std::string{ "Zn" };

	case 31:
		return std::string{ "Ga" };

	case 32:
		return std::string{ "Ge" };

	case 33:
		return std::string{ "As" };

	case 34:
		return std::string{ "Se" };

	case 35:
		return std::string{ "Br" };

	case 36:
		return std::string{ "Kr" };

	case 37:
		return std::string{ "Rb" };

	case 38:
		return std::string{ "Sr" };

	case 39:
		return std::string{ "Y" };

	case 40:
		return std::string{ "Zr" };

	case 41:
		return std::string{ "Nb" };

	case 42:
		return std::string{ "Mo" };

	case 43:
		return std::string{ "Tc" };

	case 44:
		return std::string{ "Ru" };

	case 45:
		return std::string{ "Rh" };

	case 46:
		return std::string{ "Pd" };

	case 47:
		return std::string{ "Ag" };

	case 48:
		return std::string{ "Cd" };

	case 49:
		return std::string{ "In" };

	case 50:
		return std::string{ "Sn" };

	case 51:
		return std::string{ "Sb" };

	case 52:
		return std::string{ "Te" };

	case 53:
		return std::string{ "I" };

	case 54:
		return std::string{ "Xe" };

	case 55:
		return std::string{ "Cs" };

	case 56:
		return std::string{ "Ba" };

	case 57:
		return std::string{ "La" };

	case 58:
		return std::string{ "Ce" };

	case 59:
		return std::string{ "Pr" };

	case 60:
		return std::string{ "Nd" };

	case 61:
		return std::string{ "Pm" };

	case 62:
		return std::string{ "Sm" };

	case 63:
		return std::string{ "Eu" };

	case 64:
		return std::string{ "Gd" };

	case 65:
		return std::string{ "Tb" };

	case 66:
		return std::string{ "Dy" };

	case 67:
		return std::string{ "Ho" };

	case 68:
		return std::string{ "Er" };

	case 69:
		return std::string{ "Tm" };

	case 70:
		return std::string{ "Yb" };

	case 71:
		return std::string{ "Lu" };

	case 72:
		return std::string{ "Hf" };

	case 73:
		return std::string{ "Ta" };

	case 74:
		return std::string{ "W" };

	case 75:
		return std::string{ "Re" };

	case 76:
		return std::string{ "Os" };

	case 77:
		return std::string{ "Ir" };

	case 78:
		return std::string{ "Pt" };

	case 79:
		return std::string{ "Au" };

	case 80:
		return std::string{ "Hg" };

	case 81:
		return std::string{ "Tl" };

	case 82:
		return std::string{ "Pb" };

	case 83:
		return std::string{ "Bi" };

	case 84:
		return std::string{ "Po" };

	case 85:
		return std::string{ "At" };

	case 86:
		return std::string{ "Rn" };

	case 87:
		return std::string{ "Fr" };

	case 88:
		return std::string{ "Ra" };

	case 89:
		return std::string{ "Ac" };

	case 90:
		return std::string{ "Th" };

	case 91:
		return std::string{ "Pa" };

	case 92:
		return std::string{ "U" };

	case 93:
		return std::string{ "Np" };

	case 94:
		return std::string{ "Pu" };

	default:
		return std::string{ "" };
	}
}

double PeriodicTable::replyAtomicWeight(const std::size_t atomicNumber)
{
	validateAtomicNumber(atomicNumber);

	switch (atomicNumber)
	{
	case 1:
		return 1.00784;

	case 2:
		return 4.002602;

	case 3:
		return 6.938;

	case 4:
		return 9.0121831;

	case 5:
		return 10.806;

	case 6:
		return 12.0096;

	case 7:
		return 14.00643;

	case 8:
		return 15.99903;

	case 9:
		return 18.998403162;

	case 10:
		return 20.1797;

	case 11:
		return 22.98976928;

	case 12:
		return 24.304;

	case 13:
		return 26.9815384;

	case 14:
		return 28.084;

	case 15:
		return 30.973761998;

	case 16:
		return 32.059;

	case 17:
		return 35.446;

	case 18:
		return 39.792;

	case 19:
		return 39.0983;

	case 20:
		return 40.078;

	case 21:
		return 44.955907;

	case 22:
		return 47.867;

	case 23:
		return 50.9415;

	case 24:
		return 51.9961;

	case 25:
		return 54.938043;

	case 26:
		return 55.845;

	case 27:
		return 58.933194;

	case 28:
		return 58.6934;

	case 29:
		return 63.546;

	case 30:
		return 65.38;

	case 31:
		return 69.723;

	case 32:
		return 72.630;

	case 33:
		return 74.921595;

	case 34:
		return 78.971;

	case 35:
		return 79.901;

	case 36:
		return 83.798;

	case 37:
		return 85.4678;

	case 38:
		return 87.62;

	case 39:
		return 88.905838;

	case 40:
		return 91.224;

	case 41:
		return 92.90637;

	case 42:
		return 95.95;

	case 44:
		return 101.07;

	case 45:
		return 102.90549;

	case 46:
		return 106.42;

	case 47:
		return 107.8682;

	case 48:
		return 112.414;

	case 49:
		return 114.818;

	case 50:
		return 118.710;

	case 51:
		return 121.760;

	case 52:
		return 127.60;

	case 53:
		return 126.90447;

	case 54:
		return 131.293;

	case 55:
		return 132.90545196;

	case 56:
		return 137.327;

	case 57:
		return 138.90547;

	case 58:
		return 140.116;

	case 59:
		return 140.90766;

	case 60:
		return 144.242;

	case 62:
		return 150.36;

	case 63:
		return 151.964;

	case 64:
		return 157.25;

	case 65:
		return 158.925354;

	case 66:
		return 162.5;

	case 67:
		return 164.930329;

	case 68:
		return 167.259;

	case 69:
		return 168.934219;

	case 70:
		return 173.045;

	case 71:
		return 174.9668;

	case 72:
		return 178.486;

	case 73:
		return 180.94788;

	case 74:
		return 183.84;

	case 75:
		return 186.207;

	case 76:
		return 190.23;

	case 77:
		return 192.217;

	case 78:
		return 195.084;

	case 79:
		return 196.966570;

	case 80:
		return 200.592;

	case 81:
		return 204.382;

	case 82:
		return 206.14;

	case 83:
		return 208.98040;

	case 90:
		return 232.0377;

	case 91:
		return 231.03588;

	case 92:
		return 238.02891;

	default:
		return -1.0;
	}
}

// Public methods
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
// Private methods

std::size_t PeriodicTable::translateElementSymbol(const std::string& elementSymbol) noexcept
{
	if (elementSymbol == "H")
		return 1;

	else if (elementSymbol == "He")
		return 2;

	else if (elementSymbol == "Li")
		return 3;

	else if (elementSymbol == "Be")
		return 4;

	else if (elementSymbol == "B")
		return 5;

	else if (elementSymbol == "C")
		return 6;

	else if (elementSymbol == "N")
		return 7;

	else if (elementSymbol == "O")
		return 8;

	else if (elementSymbol == "F")
		return 9;

	else if (elementSymbol == "Ne")
		return 10;

	else if (elementSymbol == "Na")
		return 11;

	else if (elementSymbol == "Mg")
		return 12;

	else if (elementSymbol == "Al")
		return 13;

	else if (elementSymbol == "Si")
		return 14;

	else if (elementSymbol == "P")
		return 15;

	else if (elementSymbol == "S")
		return 16;

	else if (elementSymbol == "Cl")
		return 17;

	else if (elementSymbol == "Ar")
		return 18;

	else if (elementSymbol == "K")
		return 19;

	else if (elementSymbol == "Ca")
		return 20;

	else if (elementSymbol == "Sc")
		return 21;

	else if (elementSymbol == "Ti")
		return 22;

	else if (elementSymbol == "V")
		return 23;

	else if (elementSymbol == "Cr")
		return 24;

	else if (elementSymbol == "Mn")
		return 25;

	else if (elementSymbol == "Fe")
		return 26;

	else if (elementSymbol == "Co")
		return 27;

	else if (elementSymbol == "Ni")
		return 28;

	else if (elementSymbol == "Cu")
		return 29;

	else if (elementSymbol == "Zn")
		return 30;

	else if (elementSymbol == "Ga")
		return 31;

	else if (elementSymbol == "Ge")
		return 32;

	else if (elementSymbol == "As")
		return 33;

	else if (elementSymbol == "Se")
		return 34;

	else if (elementSymbol == "Br")
		return 35;

	else if (elementSymbol == "Kr")
		return 36;

	else if (elementSymbol == "Rb")
		return 37;

	else if (elementSymbol == "Sr")
		return 38;

	else if (elementSymbol == "Y")
		return 39;

	else if (elementSymbol == "Zr")
		return 40;

	else if (elementSymbol == "Nb")
		return 41;

	else if (elementSymbol == "Mo")
		return 42;

	else if (elementSymbol == "Tc")
		return 43;

	else if (elementSymbol == "Ru")
		return 44;

	else if (elementSymbol == "Rh")
		return 45;

	else if (elementSymbol == "Pd")
		return 46;

	else if (elementSymbol == "Ag")
		return 47;

	else if (elementSymbol == "Cd")
		return 48;

	else if (elementSymbol == "In")
		return 49;

	else if (elementSymbol == "Sn")
		return 50;

	else if (elementSymbol == "Sb")
		return 51;

	else if (elementSymbol == "Te")
		return 52;

	else if (elementSymbol == "I")
		return 53;

	else if (elementSymbol == "Xe")
		return 54;

	else if (elementSymbol == "Cs")
		return 55;

	else if (elementSymbol == "Ba")
		return 56;

	else if (elementSymbol == "La")
		return 57;

	else if (elementSymbol == "Ce")
		return 58;

	else if (elementSymbol == "Pr")
		return 59;

	else if (elementSymbol == "Nd")
		return 60;

	else if (elementSymbol == "Pm")
		return 61;

	else if (elementSymbol == "Sm")
		return 62;

	else if (elementSymbol == "Eu")
		return 63;

	else if (elementSymbol == "Gd")
		return 64;

	else if (elementSymbol == "Tb")
		return 65;

	else if (elementSymbol == "Dy")
		return 66;

	else if (elementSymbol == "Ho")
		return 67;

	else if (elementSymbol == "Er")
		return 68;

	else if (elementSymbol == "Tm")
		return 69;

	else if (elementSymbol == "Yb")
		return 70;

	else if (elementSymbol == "Lu")
		return 71;

	else if (elementSymbol == "Hf")
		return 72;

	else if (elementSymbol == "Ta")
		return 73;

	else if (elementSymbol == "W")
		return 74;

	else if (elementSymbol == "Re")
		return 75;

	else if (elementSymbol == "Os")
		return 76;

	else if (elementSymbol == "Ir")
		return 77;

	else if (elementSymbol == "Pt")
		return 78;

	else if (elementSymbol == "Au")
		return 79;

	else if (elementSymbol == "Hg")
		return 80;

	else if (elementSymbol == "Tl")
		return 81;

	else if (elementSymbol == "Pb")
		return 82;

	else if (elementSymbol == "Bi")
		return 83;

	else if (elementSymbol == "Po")
		return 84;

	else if (elementSymbol == "At")
		return 85;

	else if (elementSymbol == "Rn")
		return 86;

	else if (elementSymbol == "Fr")
		return 87;

	else if (elementSymbol == "Ra")
		return 88;

	else if (elementSymbol == "Ac")
		return 89;

	else if (elementSymbol == "Th")
		return 90;

	else if (elementSymbol == "Pa")
		return 91;

	else if (elementSymbol == "U")
		return 92;

	else if (elementSymbol == "Np")
		return 93;

	else if (elementSymbol == "Pu")
		return 94;

	else
		return 0;
}

// Private methods
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
