#include "RequestedFeedstocks.h"

#include <set>

#include "PeriodicTable.h"

using namespace ControlCenter::Administering;

// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
// Constructor

RequestedFeedstocks::RequestedFeedstocks()
	: m_feedstocksPerChemicalConstituents{ 0 }
	, m_targetChemicalConstituents{}
{
}

// Constructor
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
// Utility

std::string RequestedFeedstocks::getRequestName() const
{
	if (isValid())
	{
		std::string chemicalSystemName;
		{
			std::set<std::string> chemicalElements;

			for (const auto& chemicalConstituents : m_targetChemicalConstituents)
			{
				for (const auto& numAndCount : chemicalConstituents)
				{
					std::string elementSymbol = SolidStatePhysics::ChemicalElements::PeriodicTable::replyElementSymbol(numAndCount.first);

					if (chemicalElements.find(elementSymbol) == chemicalElements.end())
						chemicalElements.emplace(elementSymbol);
				}
			}

			for (const auto& symbol : chemicalElements)
			{
				chemicalSystemName += symbol;
				chemicalSystemName += "-";
			}

			chemicalSystemName.pop_back();
		}

		return chemicalSystemName;
	}

	else
	{
		std::string errorMessage = "------------------------------------------------------\n\n";
		errorMessage += "Error   : Logic error\n";
		errorMessage += "Location: The member function of \"getChemicalSystemName\" in the class of ControlCenter::Administering::RequestedFeedstocks.\n";
		errorMessage += "Message : This is invalid.\n\n";
		errorMessage += "------------------------------------------------------\n\n";
		throw std::logic_error(errorMessage);
	}
}

// Utility
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
